﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace XamDataTreeConditionalCPDemo
{
    public class ViewModel
    {
        public List<SampleData> Data { get; set; }

        public ViewModel()
        {
            Data = new List<SampleData>();

            for (int i = 0; i < 15; i++)
            {
                SampleData sd = new SampleData() { Label = "Text Label " + i.ToString(), Date = DateTime.Today.AddDays(i) };
                if (i % 3 == 0)
                {
                    sd.UseTextBlock = true;
                }
                else if(i % 3 == 1)
                {
                    sd.UseTextEditor = true;
                }
                else
                {
                    sd.UseDateTimeEditor = true;
                }

                Data.Add(sd);
            }
        }
    }

    public class SampleData : INotifyPropertyChanged
    {
        private string _label;
        private DateTime _date;

        public string Label
        {
            get { return _label; }
            set
            {
                _label = value;
                NotifyPropertyChanged();
            }
        }

        public DateTime Date
        {
            get { return _date; }
            set
            {
                _date = value;
                NotifyPropertyChanged();
            }
        }

        public bool UseTextBlock { get; set; }
        public bool UseTextEditor { get; set; }
        public bool UseDateTimeEditor { get; set; }


        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
